Overview
--------

OpenContrail (www.opencontrail.org) is a fully featured Software Defined
Networking (SDN) solution for private clouds. It supports high performance
isolated tenant networks without requiring external hardware support. It
provides a Neutron plugin to integrate with OpenStack.

This charm is designed to be used in conjunction with the rest of the OpenStack
related charms in the charm store to virtualize the network that Nova Compute
instances plug into.

This charm provides the configuration node component which includes
contrail-api, contrail-schema, contrail-discovery and ifmap-server services.
Only OpenStack Icehouse or newer is supported.

Usage
-----

This charm is written to work with the neutron-api charm, which must be deployed
with 'neutron-plugin' set to 'contrail':

    neutron-api:
        neutron-plugin: contrail

Cassandra, Zookeeper, RabbitMQ and Keystone are prerequisite services to deploy.
Once ready, deploy and relate as follows:

    juju deploy contrail-configuration
    juju add-relation contrail-configuration:cassandra cassandra:database
    juju add-relation contrail-configuration zookeeper
    juju add-relation contrail-configuration rabbitmq-server
    juju add-relation contrail-configuration keystone

Relating to a neutron/quantum gateway charm will register a linklocal service
which Nova Compute instances can use to access nova proxy and obtain cloud
metadata such as SSH keys:

    juju add-relation contrail-configuration neutron-gateway

After deployment, relate to neutron-api:

    juju add-relation neutron-api contrail-configuration
